/***************************************************************************
 *
 * Copyright (c) 2000, 2001, 2002 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published
 * by the Free Software Foundation.
 *
 * Note that this permission is granted for only version 2 of the GPL.
 *
 * As an additional exemption you are allowed to compile & link against the
 * OpenSSL libraries as published by the OpenSSL project. See the file
 * COPYING for details.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: code.h,v 1.2.2.2 2002/10/30 06:20:40 sasa Exp $
 *
 ***************************************************************************/
       
#ifndef ZORP_CODE_H_INCLUDED
#define ZORP_CODE_H_INCLUDED
       
#define Z_CODE_NULL   0
#define Z_CODE_BASE64 1
#define Z_CODE_QUOTED 2

#include <glib.h>

struct _ZCode;

typedef gboolean (*z_code_decode)(struct  _ZCode *code,
                                           gchar *from,
                                           guint  fromlen,
                                           gchar *to,
                                           guint *tolen);
                            
typedef gboolean (*z_code_encode)(struct  _ZCode *code,
                                           gchar *from,
                                           guint  fromlen,
                                           gchar *to,
                                           guint *tolen);

typedef struct _ZCode
{
  guint type;
  z_code_decode decode;
  z_code_encode encode;
} ZCode;
    
#endif
