/***************************************************************************
 *
 * Copyright (c) 2000, 2001, 2002 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published
 * by the Free Software Foundation.
 *
 * Note that this permission is granted for only version 2 of the GPL.
 *
 * As an additional exemption you are allowed to compile & link against the
 * OpenSSL libraries as published by the OpenSSL project. See the file
 * COPYING for details.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: proxyvars.h,v 1.2.2.3 2002/11/13 09:05:38 bazsi Exp $
 *
 ***************************************************************************/

#ifndef ZORP_PYVARS_H_INCLUDED
#define ZORP_PYVARS_H_INCLUDED

#include <zorp/zorp.h>
#include <zorp/policy.h>

struct _ZProxy;

typedef struct _ZProxyVars 
{
  GHashTable *vars;
  struct _ZSessionVars *session_vars;
} ZProxyVars;

typedef struct _ZSessionVars
{
  GHashTable *vars;
} ZSessionVars;

/* callbacks usable as Python callbacks for setattr/getattr */
gint z_proxy_vars_setattr(struct _ZProxy *self, gchar *name, ZPolicyObj *new);

ZPolicyObj *z_proxy_vars_getattr(struct _ZProxy *self, gchar *name);

ZProxyVars *z_proxy_vars_new(void);
void z_proxy_vars_destroy(ZProxyVars *vars);
void z_proxy_vars_dump_values(ZProxyVars *vars, struct _ZProxy *proxy);
void z_proxy_vars_set_session(ZProxyVars *vars, ZSessionVars *session);
void z_proxy_vars_var_new(GHashTable *hash, gchar *name, guint flags, ...);
void z_proxy_vars_set_active_session(struct _ZProxy *self, struct _ZSessionVars *vars);

ZSessionVars *z_session_vars_new(void);
void z_session_vars_destroy(ZSessionVars *self);

#endif
